#define M1A  5
#define M1B  3
#define M2A  10
#define M2B  9

//왼쪽 초음파 센서 
#define left_TRIG 2
#define left_ECHO 4
//오른쪽 초음파 센서
#define right_TRIG 6
#define right_ECHO 11

void setup() {
  //초음파센서들 세팅
  pinMode(left_TRIG, OUTPUT);
  pinMode(left_ECHO, INPUT);
  pinMode(right_TRIG, OUTPUT);
  pinMode(right_ECHO, INPUT);
  
  //모터 세팅
  pinMode(M1A, OUTPUT);
  pinMode(M1B, OUTPUT);
  pinMode(M2A, OUTPUT);
  pinMode(M2B, OUTPUT);
}

int left_duration;
int left_distance;
int right_duration;
int right_distance;

void loop() {
  // put your main code here, to run repeatedly:
  left_ultrasonic();
  right_ultrasonic();
 
  superpower();
}

void left_ultrasonic(){
        digitalWrite(left_TRIG,LOW);
        digitalWrite(left_ECHO,LOW);
        delay(2);
        digitalWrite(left_TRIG,HIGH);
        delay(10);
        digitalWrite(left_TRIG,LOW);


        left_duration = pulseIn(left_ECHO,HIGH);
        left_distance =  left_duration / 29.0/ 2.0; //340 * duration * 0.001 / 2;
}

void right_ultrasonic(){
        digitalWrite(right_TRIG,LOW);
        digitalWrite(right_ECHO,LOW);
        delay(2);
        digitalWrite(right_TRIG,HIGH);
        delay(10);
        digitalWrite(right_TRIG,LOW);

       
        right_duration = pulseIn(right_ECHO,HIGH);
        right_distance =  right_duration / 29.0/ 2.0; //340 * duration * 0.001 / 2;
}

void Stop() {
  analogWrite(M1A, 0);
  analogWrite(M1B, 0);
  analogWrite(M2A, 0);
  analogWrite(M2B, 0);
//정지
}

void B_Left(int spd){
  analogWrite(M1A, 0);
  analogWrite(M1B, (spd/3));
  analogWrite(M2A, 0);
  analogWrite(M2B, spd);
//좌후진(후진하면서)
}

void B_Right(int spd){
  analogWrite(M1A, 0);
  analogWrite(M1B, spd);
  analogWrite(M2A, 0);
  analogWrite(M2B, (spd/3));
//우후진(후진하면서)
}
void Back (int spd){
  analogWrite(M1A, 0);
  analogWrite(M1B, spd);
  analogWrite(M2A, 0);
  analogWrite(M2B, spd);
//뒤로 후진
}
void Foward(int spd) { 
  analogWrite(M1A, spd);
  analogWrite(M1B, 0);
  analogWrite(M2A, spd);
  analogWrite(M2B, 0);
//앞으로 전진
  }

void F_Right(int spd) {
  analogWrite(M1A, (spd/3));
  analogWrite(M1B, 0);
  analogWrite(M2A, spd);
  analogWrite(M2B, 0);
//우회전(전진하면서)
}

void F_Left(int spd) {
  analogWrite(M1A, spd);
  analogWrite(M1B, 0);
  analogWrite(M2A, (spd/3));
  analogWrite(M2B, 0);
//좌회전(전진하면서)
}

void superpower(){
  if(right_distance>=0&&right_distance<6)
  {
    if(left_distance>=0&&left_distance<6)
    {
      Back(255);
      delay(10);
    }
    else
    {
      B_Left(255);
      delay(10);
    }
  }
  else if(left_distance>=0&&left_distance<6)
  {
   B_Right(255);
    delay(10);
  }
  
  else if(right_distance>=6&&right_distance<10)
  {
    if(left_distance>=6&&left_distance<10)
    {
      Back(255);
      delay(10);
      Back(180);
      delay(10);
    }
    else
    {
      B_Left(255);
      delay(10);
      B_Left(180);
      delay(10);
    }
  }
  else if(left_distance>=6&&left_distance<10)
  {
    B_Right(255);
    delay(10);
    B_Right(180);
    delay(10);
  }

  else if(right_distance>=11&&right_distance<15)
  {
    if(left_distance>=11&&left_distance<15)
    {
      Foward(255);
      delay(10);
      Foward(180);
      delay(10);
    }
    else
    {
      F_Left(255);
      delay(10);
      F_Left(180);
      delay(10);
    }
  }
  else if(left_distance>=11&&left_distance<15)
  {
    F_Right(255);
    delay(10);
    F_Right(180);
    delay(10);
  }
  
  else if(right_distance>=15&&right_distance<20)
  {
    if(left_distance>=15&&left_distance<20)
    {
      Foward(255);
      delay(10);
    }
    else
    {
      F_Left(255);
      delay(10);
    }
  }
  else if(left_distance>=15&&left_distance<20)
  {
    F_Right(255);
    delay(10);
  }
  else
  {
    Stop();
  }
}

